︠fcea7e8c-b9d0-405e-8d52-b45b32454d83︠
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.model_selection import train_test_split
from sklearn.datasets import load_boston
import seaborn as sns
from sklearn import preprocessing
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
from sklearn.metrics import r2_score
import matplotlib.pyplot as plt
from sklearn import preprocessing

boston = load_boston()

print(boston)
︡641d12c7-6167-4c29-8b94-0d63843ccb58︡{"stdout":"{'data': array([[  6.32000000e-03,   1.80000000e+01,   2.31000000e+00, ...,\n          1.53000000e+01,   3.96900000e+02,   4.98000000e+00],\n       [  2.73100000e-02,   0.00000000e+00,   7.07000000e+00, ...,\n          1.78000000e+01,   3.96900000e+02,   9.14000000e+00],\n       [  2.72900000e-02,   0.00000000e+00,   7.07000000e+00, ...,\n          1.78000000e+01,   3.92830000e+02,   4.03000000e+00],\n       ..., \n       [  6.07600000e-02,   0.00000000e+00,   1.19300000e+01, ...,\n          2.10000000e+01,   3.96900000e+02,   5.64000000e+00],\n       [  1.09590000e-01,   0.00000000e+00,   1.19300000e+01, ...,\n          2.10000000e+01,   3.93450000e+02,   6.48000000e+00],\n       [  4.74100000e-02,   0.00000000e+00,   1.19300000e+01, ...,\n          2.10000000e+01,   3.96900000e+02,   7.88000000e+00]]), 'feature_names': array(['CRIM', 'ZN', 'INDUS', 'CHAS', 'NOX', 'RM', 'AGE', 'DIS', 'RAD',\n       'TAX', 'PTRATIO', 'B', 'LSTAT'],\n      dtype='|S7'), 'DESCR': \"Boston House Prices dataset\\n===========================\\n\\nNotes\\n------\\nData Set Characteristics:  \\n\\n    :Number of Instances: 506 \\n\\n    :Number of Attributes: 13 numeric/categorical predictive\\n    \\n    :Median Value (attribute 14) is usually the target\\n\\n    :Attribute Information (in order):\\n        - CRIM     per capita crime rate by town\\n        - ZN       proportion of residential land zoned for lots over 25,000 sq.ft.\\n        - INDUS    proportion of non-retail business acres per town\\n        - CHAS     Charles River dummy variable (= 1 if tract bounds river; 0 otherwise)\\n        - NOX      nitric oxides concentration (parts per 10 million)\\n        - RM       average number of rooms per dwelling\\n        - AGE      proportion of owner-occupied units built prior to 1940\\n        - DIS      weighted distances to five Boston employment centres\\n        - RAD      index of accessibility to radial highways\\n        - TAX      full-value property-tax rate per $10,000\\n        - PTRATIO  pupil-teacher ratio by town\\n        - B        1000(Bk - 0.63)^2 where Bk is the proportion of blacks by town\\n        - LSTAT    % lower status of the population\\n        - MEDV     Median value of owner-occupied homes in $1000's\\n\\n    :Missing Attribute Values: None\\n\\n    :Creator: Harrison, D. and Rubinfeld, D.L.\\n\\nThis is a copy of UCI ML housing dataset.\\nhttp://archive.ics.uci.edu/ml/datasets/Housing\\n\\n\\nThis dataset was taken from the StatLib library which is maintained at Carnegie Mellon University.\\n\\nThe Boston house-price data of Harrison, D. and Rubinfeld, D.L. 'Hedonic\\nprices and the demand for clean air', J. Environ. Economics & Management,\\nvol.5, 81-102, 1978.   Used in Belsley, Kuh & Welsch, 'Regression diagnostics\\n...', Wiley, 1980.   N.B. Various transformations are used in the table on\\npages 244-261 of the latter.\\n\\nThe Boston house-price data has been used in many machine learning papers that address regression\\nproblems.   \\n     \\n**References**\\n\\n   - Belsley, Kuh & Welsch, 'Regression diagnostics: Identifying Influential Data and Sources of Collinearity', Wiley, 1980. 244-261.\\n   - Quinlan,R. (1993). Combining Instance-Based and Model-Based Learning. In Proceedings on the Tenth International Conference of Machine Learning, 236-243, University of Massachusetts, Amherst. Morgan Kaufmann.\\n   - many more! (see http://archive.ics.uci.edu/ml/datasets/Housing)\\n\", 'target': array([ 24. ,  21.6,  34.7,  33.4,  36.2,  28.7,  22.9,  27.1,  16.5,\n        18.9,  15. ,  18.9,  21.7,  20.4,  18.2,  19.9,  23.1,  17.5,\n        20.2,  18.2,  13.6,  19.6,  15.2,  14.5,  15.6,  13.9,  16.6,\n        14.8,  18.4,  21. ,  12.7,  14.5,  13.2,  13.1,  13.5,  18.9,\n        20. ,  21. ,  24.7,  30.8,  34.9,  26.6,  25.3,  24.7,  21.2,\n        19.3,  20. ,  16.6,  14.4,  19.4,  19.7,  20.5,  25. ,  23.4,\n        18.9,  35.4,  24.7,  31.6,  23.3,  19.6,  18.7,  16. ,  22.2,\n        25. ,  33. ,  23.5,  19.4,  22. ,  17.4,  20.9,  24.2,  21.7,\n        22.8,  23.4,  24.1,  21.4,  20. ,  20.8,  21.2,  20.3,  28. ,\n        23.9,  24.8,  22.9,  23.9,  26.6,  22.5,  22.2,  23.6,  28.7,\n        22.6,  22. ,  22.9,  25. ,  20.6,  28.4,  21.4,  38.7,  43.8,\n        33.2,  27.5,  26.5,  18.6,  19.3,  20.1,  19.5,  19.5,  20.4,\n        19.8,  19.4,  21.7,  22.8,  18.8,  18.7,  18.5,  18.3,  21.2,\n        19.2,  20.4,  19.3,  22. ,  20.3,  20.5,  17.3,  18.8,  21.4,\n        15.7,  16.2,  18. ,  14.3,  19.2,  19.6,  23. ,  18.4,  15.6,\n        18.1,  17.4,  17.1,  13.3,  17.8,  14. ,  14.4,  13.4,  15.6,\n        11.8,  13.8,  15.6,  14.6,  17.8,  15.4,  21.5,  19.6,  15.3,\n        19.4,  17. ,  15.6,  13.1,  41.3,  24.3,  23.3,  27. ,  50. ,\n        50. ,  50. ,  22.7,  25. ,  50. ,  23.8,  23.8,  22.3,  17.4,\n        19.1,  23.1,  23.6,  22.6,  29.4,  23.2,  24.6,  29.9,  37.2,\n        39.8,  36.2,  37.9,  32.5,  26.4,  29.6,  50. ,  32. ,  29.8,\n        34.9,  37. ,  30.5,  36.4,  31.1,  29.1,  50. ,  33.3,  30.3,\n        34.6,  34.9,  32.9,  24.1,  42.3,  48.5,  50. ,  22.6,  24.4,\n        22.5,  24.4,  20. ,  21.7,  19.3,  22.4,  28.1,  23.7,  25. ,\n        23.3,  28.7,  21.5,  23. ,  26.7,  21.7,  27.5,  30.1,  44.8,\n        50. ,  37.6,  31.6,  46.7,  31.5,  24.3,  31.7,  41.7,  48.3,\n        29. ,  24. ,  25.1,  31.5,  23.7,  23.3,  22. ,  20.1,  22.2,\n        23.7,  17.6,  18.5,  24.3,  20.5,  24.5,  26.2,  24.4,  24.8,\n        29.6,  42.8,  21.9,  20.9,  44. ,  50. ,  36. ,  30.1,  33.8,\n        43.1,  48.8,  31. ,  36.5,  22.8,  30.7,  50. ,  43.5,  20.7,\n        21.1,  25.2,  24.4,  35.2,  32.4,  32. ,  33.2,  33.1,  29.1,\n        35.1,  45.4,  35.4,  46. ,  50. ,  32.2,  22. ,  20.1,  23.2,\n        22.3,  24.8,  28.5,  37.3,  27.9,  23.9,  21.7,  28.6,  27.1,\n        20.3,  22.5,  29. ,  24.8,  22. ,  26.4,  33.1,  36.1,  28.4,\n        33.4,  28.2,  22.8,  20.3,  16.1,  22.1,  19.4,  21.6,  23.8,\n        16.2,  17.8,  19.8,  23.1,  21. ,  23.8,  23.1,  20.4,  18.5,\n        25. ,  24.6,  23. ,  22.2,  19.3,  22.6,  19.8,  17.1,  19.4,\n        22.2,  20.7,  21.1,  19.5,  18.5,  20.6,  19. ,  18.7,  32.7,\n        16.5,  23.9,  31.2,  17.5,  17.2,  23.1,  24.5,  26.6,  22.9,\n        24.1,  18.6,  30.1,  18.2,  20.6,  17.8,  21.7,  22.7,  22.6,\n        25. ,  19.9,  20.8,  16.8,  21.9,  27.5,  21.9,  23.1,  50. ,\n        50. ,  50. ,  50. ,  50. ,  13.8,  13.8,  15. ,  13.9,  13.3,\n        13.1,  10.2,  10.4,  10.9,  11.3,  12.3,   8.8,   7.2,  10.5,\n         7.4,  10.2,  11.5,  15.1,  23.2,   9.7,  13.8,  12.7,  13.1,\n        12.5,   8.5,   5. ,   6.3,   5.6,   7.2,  12.1,   8.3,   8.5,\n         5. ,  11.9,  27.9,  17.2,  27.5,  15. ,  17.2,  17.9,  16.3,\n         7. ,   7.2,   7.5,  10.4,   8.8,   8.4,  16.7,  14.2,  20.8,\n        13.4,  11.7,   8.3,  10.2,  10.9,  11. ,   9.5,  14.5,  14.1,\n        16.1,  14.3,  11.7,  13.4,   9.6,   8.7,   8.4,  12.8,  10.5,\n        17.1,  18.4,  15.4,  10.8,  11.8,  14.9,  12.6,  14.1,  13. ,\n        13.4,  15.2,  16.1,  17.8,  14.9,  14.1,  12.7,  13.5,  14.9,\n        20. ,  16.4,  17.7,  19.5,  20.2,  21.4,  19.9,  19. ,  19.1,\n        19.1,  20.1,  19.9,  19.6,  23.2,  29.8,  13.8,  13.3,  16.7,\n        12. ,  14.6,  21.4,  23. ,  23.7,  25. ,  21.8,  20.6,  21.2,\n        19.1,  20.6,  15.2,   7. ,   8.1,  13.6,  20.1,  21.8,  24.5,\n        23.1,  19.7,  18.3,  21.2,  17.5,  16.8,  22.4,  20.6,  23.9,\n        22. ,  11.9])}"}︡{"stdout":"\n"}︡{"done":true}︡
︠a129e88c-6cc4-4719-8f51-5309716e7b4es︠
print(boston.keys())
︡62ad627b-309f-4b41-b072-c6eeadcede75︡{"stdout":"['data', 'feature_names', 'DESCR', 'target']\n"}︡{"done":true}︡
︠fde5e8f5-1413-4983-8c57-040d7a02ae00s︠
print(boston.data.shape)
︡2a4cb53a-78db-49df-8537-97e4ab84d618︡{"stdout":"(506, 13)\n"}︡{"done":true}︡
︠cba2b919-e132-4ce0-ba4c-43ff9a151013s︠
print(boston.feature_names)
︡a1c16821-3101-4b36-85dc-81ac42db60db︡{"stdout":"['CRIM' 'ZN' 'INDUS' 'CHAS' 'NOX' 'RM' 'AGE' 'DIS' 'RAD' 'TAX' 'PTRATIO'\n 'B' 'LSTAT']\n"}︡{"done":true}︡
︠ade63657-03d4-43e1-b951-76afe6e2c7afs︠
print(boston.DESCR)
︡c797ac78-76cb-4ed6-837e-d223af852842︡{"stdout":"Boston House Prices dataset\n===========================\n\nNotes\n------\nData Set Characteristics:  \n\n    :Number of Instances: 506 \n\n    :Number of Attributes: 13 numeric/categorical predictive\n    \n    :Median Value (attribute 14) is usually the target\n\n    :Attribute Information (in order):\n        - CRIM     per capita crime rate by town\n        - ZN       proportion of residential land zoned for lots over 25,000 sq.ft.\n        - INDUS    proportion of non-retail business acres per town\n        - CHAS     Charles River dummy variable (= 1 if tract bounds river; 0 otherwise)\n        - NOX      nitric oxides concentration (parts per 10 million)\n        - RM       average number of rooms per dwelling\n        - AGE      proportion of owner-occupied units built prior to 1940\n        - DIS      weighted distances to five Boston employment centres\n        - RAD      index of accessibility to radial highways\n        - TAX      full-value property-tax rate per $10,000\n        - PTRATIO  pupil-teacher ratio by town\n        - B        1000(Bk - 0.63)^2 where Bk is the proportion of blacks by town\n        - LSTAT    % lower status of the population\n        - MEDV     Median value of owner-occupied homes in $1000's\n\n    :Missing Attribute Values: None\n\n    :Creator: Harrison, D. and Rubinfeld, D.L.\n\nThis is a copy of UCI ML housing dataset.\nhttp://archive.ics.uci.edu/ml/datasets/Housing\n\n\nThis dataset was taken from the StatLib library which is maintained at Carnegie Mellon University.\n\nThe Boston house-price data of Harrison, D. and Rubinfeld, D.L. 'Hedonic\nprices and the demand for clean air', J. Environ. Economics & Management,\nvol.5, 81-102, 1978.   Used in Belsley, Kuh & Welsch, 'Regression diagnostics\n...', Wiley, 1980.   N.B. Various transformations are used in the table on\npages 244-261 of the latter.\n\nThe Boston house-price data has been used in many machine learning papers that address regression\nproblems.   \n     \n**References**\n\n   - Belsley, Kuh & Welsch, 'Regression diagnostics: Identifying Influential Data and Sources of Collinearity', Wiley, 1980. 244-261.\n   - Quinlan,R. (1993). Combining Instance-Based and Model-Based Learning. In Proceedings on the Tenth International Conference of Machine Learning, 236-243, University of Massachusetts, Amherst. Morgan Kaufmann.\n   - many more! (see http://archive.ics.uci.edu/ml/datasets/Housing)\n\n"}︡{"done":true}︡
︠41814759-a5bc-4be7-8b8f-dcf6476df7ccs︠
boston_df = pd.DataFrame(boston.data)
boston_df.columns = boston.feature_names
print(boston_df.head())
︡f813dc8d-ca46-4338-8cf7-6967569c259f︡{"stdout":"      CRIM    ZN  INDUS  CHAS    NOX     RM   AGE     DIS  RAD    TAX  \\\n0  0.00632  18.0   2.31   0.0  0.538  6.575  65.2  4.0900  1.0  296.0   \n1  0.02731   0.0   7.07   0.0  0.469  6.421  78.9  4.9671  2.0  242.0   \n2  0.02729   0.0   7.07   0.0  0.469  7.185  61.1  4.9671  2.0  242.0   \n3  0.03237   0.0   2.18   0.0  0.458  6.998  45.8  6.0622  3.0  222.0   \n4  0.06905   0.0   2.18   0.0  0.458  7.147  54.2  6.0622  3.0  222.0   \n\n   PTRATIO       B  LSTAT  \n0     15.3  396.90   4.98  \n1     17.8  396.90   9.14  \n2     17.8  392.83   4.03  \n3     18.7  394.63   2.94  \n4     18.7  396.90   5.33  \n"}︡{"done":true}︡
︠97c4c408-dcfc-4a55-b620-9198d89fd5aas︠
print(boston.target.shape)
︡942e19a5-15d6-455a-87a6-79620eea12cb︡{"stdout":"(506,)\n"}︡{"done":true}︡
︠97d557ac-a1ab-4819-99f5-11841e57abe5s︠

boston_df['PRICE'] = boston.target
print(boston_df.head())
︡9c005475-8459-4ebc-baa4-e9e99c7a2387︡{"stdout":"      CRIM    ZN  INDUS  CHAS    NOX     RM   AGE     DIS  RAD    TAX  \\\n0  0.00632  18.0   2.31   0.0  0.538  6.575  65.2  4.0900  1.0  296.0   \n1  0.02731   0.0   7.07   0.0  0.469  6.421  78.9  4.9671  2.0  242.0   \n2  0.02729   0.0   7.07   0.0  0.469  7.185  61.1  4.9671  2.0  242.0   \n3  0.03237   0.0   2.18   0.0  0.458  6.998  45.8  6.0622  3.0  222.0   \n4  0.06905   0.0   2.18   0.0  0.458  7.147  54.2  6.0622  3.0  222.0   \n\n   PTRATIO       B  LSTAT  PRICE  \n0     15.3  396.90   4.98   24.0  \n1     17.8  396.90   9.14   21.6  \n2     17.8  392.83   4.03   34.7  \n3     18.7  394.63   2.94   33.4  \n4     18.7  396.90   5.33   36.2  \n"}︡{"done":true}︡
︠c088da82-74ef-4d9b-b6c8-720559028f55s︠
print(boston_df.describe)
︡9e74f6f8-9401-4e29-abe9-a5f4431890e0︡{"stdout":"<bound method DataFrame.describe of          CRIM    ZN  INDUS  CHAS    NOX     RM    AGE     DIS   RAD    TAX  \\\n0     0.00632  18.0   2.31   0.0  0.538  6.575   65.2  4.0900   1.0  296.0   \n1     0.02731   0.0   7.07   0.0  0.469  6.421   78.9  4.9671   2.0  242.0   \n2     0.02729   0.0   7.07   0.0  0.469  7.185   61.1  4.9671   2.0  242.0   \n3     0.03237   0.0   2.18   0.0  0.458  6.998   45.8  6.0622   3.0  222.0   \n4     0.06905   0.0   2.18   0.0  0.458  7.147   54.2  6.0622   3.0  222.0   \n5     0.02985   0.0   2.18   0.0  0.458  6.430   58.7  6.0622   3.0  222.0   \n6     0.08829  12.5   7.87   0.0  0.524  6.012   66.6  5.5605   5.0  311.0   \n7     0.14455  12.5   7.87   0.0  0.524  6.172   96.1  5.9505   5.0  311.0   \n8     0.21124  12.5   7.87   0.0  0.524  5.631  100.0  6.0821   5.0  311.0   \n9     0.17004  12.5   7.87   0.0  0.524  6.004   85.9  6.5921   5.0  311.0   \n10    0.22489  12.5   7.87   0.0  0.524  6.377   94.3  6.3467   5.0  311.0   \n11    0.11747  12.5   7.87   0.0  0.524  6.009   82.9  6.2267   5.0  311.0   \n12    0.09378  12.5   7.87   0.0  0.524  5.889   39.0  5.4509   5.0  311.0   \n13    0.62976   0.0   8.14   0.0  0.538  5.949   61.8  4.7075   4.0  307.0   \n14    0.63796   0.0   8.14   0.0  0.538  6.096   84.5  4.4619   4.0  307.0   \n15    0.62739   0.0   8.14   0.0  0.538  5.834   56.5  4.4986   4.0  307.0   \n16    1.05393   0.0   8.14   0.0  0.538  5.935   29.3  4.4986   4.0  307.0   \n17    0.78420   0.0   8.14   0.0  0.538  5.990   81.7  4.2579   4.0  307.0   \n18    0.80271   0.0   8.14   0.0  0.538  5.456   36.6  3.7965   4.0  307.0   \n19    0.72580   0.0   8.14   0.0  0.538  5.727   69.5  3.7965   4.0  307.0   \n20    1.25179   0.0   8.14   0.0  0.538  5.570   98.1  3.7979   4.0  307.0   \n21    0.85204   0.0   8.14   0.0  0.538  5.965   89.2  4.0123   4.0  307.0   \n22    1.23247   0.0   8.14   0.0  0.538  6.142   91.7  3.9769   4.0  307.0   \n23    0.98843   0.0   8.14   0.0  0.538  5.813  100.0  4.0952   4.0  307.0   \n24    0.75026   0.0   8.14   0.0  0.538  5.924   94.1  4.3996   4.0  307.0   \n25    0.84054   0.0   8.14   0.0  0.538  5.599   85.7  4.4546   4.0  307.0   \n26    0.67191   0.0   8.14   0.0  0.538  5.813   90.3  4.6820   4.0  307.0   \n27    0.95577   0.0   8.14   0.0  0.538  6.047   88.8  4.4534   4.0  307.0   \n28    0.77299   0.0   8.14   0.0  0.538  6.495   94.4  4.4547   4.0  307.0   \n29    1.00245   0.0   8.14   0.0  0.538  6.674   87.3  4.2390   4.0  307.0   \n..        ...   ...    ...   ...    ...    ...    ...     ...   ...    ...   \n476   4.87141   0.0  18.10   0.0  0.614  6.484   93.6  2.3053  24.0  666.0   \n477  15.02340   0.0  18.10   0.0  0.614  5.304   97.3  2.1007  24.0  666.0   \n478  10.23300   0.0  18.10   0.0  0.614  6.185   96.7  2.1705  24.0  666.0   \n479  14.33370   0.0  18.10   0.0  0.614  6.229   88.0  1.9512  24.0  666.0   \n480   5.82401   0.0  18.10   0.0  0.532  6.242   64.7  3.4242  24.0  666.0   \n481   5.70818   0.0  18.10   0.0  0.532  6.750   74.9  3.3317  24.0  666.0   \n482   5.73116   0.0  18.10   0.0  0.532  7.061   77.0  3.4106  24.0  666.0   \n483   2.81838   0.0  18.10   0.0  0.532  5.762   40.3  4.0983  24.0  666.0   \n484   2.37857   0.0  18.10   0.0  0.583  5.871   41.9  3.7240  24.0  666.0   \n485   3.67367   0.0  18.10   0.0  0.583  6.312   51.9  3.9917  24.0  666.0   \n486   5.69175   0.0  18.10   0.0  0.583  6.114   79.8  3.5459  24.0  666.0   \n487   4.83567   0.0  18.10   0.0  0.583  5.905   53.2  3.1523  24.0  666.0   \n488   0.15086   0.0  27.74   0.0  0.609  5.454   92.7  1.8209   4.0  711.0   \n489   0.18337   0.0  27.74   0.0  0.609  5.414   98.3  1.7554   4.0  711.0   \n490   0.20746   0.0  27.74   0.0  0.609  5.093   98.0  1.8226   4.0  711.0   \n491   0.10574   0.0  27.74   0.0  0.609  5.983   98.8  1.8681   4.0  711.0   \n492   0.11132   0.0  27.74   0.0  0.609  5.983   83.5  2.1099   4.0  711.0   \n493   0.17331   0.0   9.69   0.0  0.585  5.707   54.0  2.3817   6.0  391.0   \n494   0.27957   0.0   9.69   0.0  0.585  5.926   42.6  2.3817   6.0  391.0   \n495   0.17899   0.0   9.69   0.0  0.585  5.670   28.8  2.7986   6.0  391.0   \n496   0.28960   0.0   9.69   0.0  0.585  5.390   72.9  2.7986   6.0  391.0   \n497   0.26838   0.0   9.69   0.0  0.585  5.794   70.6  2.8927   6.0  391.0   \n498   0.23912   0.0   9.69   0.0  0.585  6.019   65.3  2.4091   6.0  391.0   \n499   0.17783   0.0   9.69   0.0  0.585  5.569   73.5  2.3999   6.0  391.0   \n500   0.22438   0.0   9.69   0.0  0.585  6.027   79.7  2.4982   6.0  391.0   \n501   0.06263   0.0  11.93   0.0  0.573  6.593   69.1  2.4786   1.0  273.0   \n502   0.04527   0.0  11.93   0.0  0.573  6.120   76.7  2.2875   1.0  273.0   \n503   0.06076   0.0  11.93   0.0  0.573  6.976   91.0  2.1675   1.0  273.0   \n504   0.10959   0.0  11.93   0.0  0.573  6.794   89.3  2.3889   1.0  273.0   \n505   0.04741   0.0  11.93   0.0  0.573  6.030   80.8  2.5050   1.0  273.0   \n\n     PTRATIO       B  LSTAT  PRICE  \n0       15.3  396.90   4.98   24.0  \n1       17.8  396.90   9.14   21.6  \n2       17.8  392.83   4.03   34.7  \n3       18.7  394.63   2.94   33.4  \n4       18.7  396.90   5.33   36.2  \n5       18.7  394.12   5.21   28.7  \n6       15.2  395.60  12.43   22.9  \n7       15.2  396.90  19.15   27.1  \n8       15.2  386.63  29.93   16.5  \n9       15.2  386.71  17.10   18.9  \n10      15.2  392.52  20.45   15.0  \n11      15.2  396.90  13.27   18.9  \n12      15.2  390.50  15.71   21.7  \n13      21.0  396.90   8.26   20.4  \n14      21.0  380.02  10.26   18.2  \n15      21.0  395.62   8.47   19.9  \n16      21.0  386.85   6.58   23.1  \n17      21.0  386.75  14.67   17.5  \n18      21.0  288.99  11.69   20.2  \n19      21.0  390.95  11.28   18.2  \n20      21.0  376.57  21.02   13.6  \n21      21.0  392.53  13.83   19.6  \n22      21.0  396.90  18.72   15.2  \n23      21.0  394.54  19.88   14.5  \n24      21.0  394.33  16.30   15.6  \n25      21.0  303.42  16.51   13.9  \n26      21.0  376.88  14.81   16.6  \n27      21.0  306.38  17.28   14.8  \n28      21.0  387.94  12.80   18.4  \n29      21.0  380.23  11.98   21.0  \n..       ...     ...    ...    ...  \n476     20.2  396.21  18.68   16.7  \n477     20.2  349.48  24.91   12.0  \n478     20.2  379.70  18.03   14.6  \n479     20.2  383.32  13.11   21.4  \n480     20.2  396.90  10.74   23.0  \n481     20.2  393.07   7.74   23.7  \n482     20.2  395.28   7.01   25.0  \n483     20.2  392.92  10.42   21.8  \n484     20.2  370.73  13.34   20.6  \n485     20.2  388.62  10.58   21.2  \n486     20.2  392.68  14.98   19.1  \n487     20.2  388.22  11.45   20.6  \n488     20.1  395.09  18.06   15.2  \n489     20.1  344.05  23.97    7.0  \n490     20.1  318.43  29.68    8.1  \n491     20.1  390.11  18.07   13.6  \n492     20.1  396.90  13.35   20.1  \n493     19.2  396.90  12.01   21.8  \n494     19.2  396.90  13.59   24.5  \n495     19.2  393.29  17.60   23.1  \n496     19.2  396.90  21.14   19.7  \n497     19.2  396.90  14.10   18.3  \n498     19.2  396.90  12.92   21.2  \n499     19.2  395.77  15.10   17.5  \n500     19.2  396.90  14.33   16.8  \n501     21.0  391.99   9.67   22.4  \n502     21.0  396.90   9.08   20.6  \n503     21.0  396.90   5.64   23.9  \n504     21.0  393.45   6.48   22.0  \n505     21.0  396.90   7.88   11.9  \n\n[506 rows x 14 columns]>"}︡{"stdout":"\n"}︡{"done":true}︡
︠f30591ad-7516-4e0b-a025-555c020b1c1b︠
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.model_selection import train_test_split
from sklearn.datasets import load_boston
import seaborn as sns
from sklearn import preprocessing
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
from sklearn.metrics import r2_score
import matplotlib.pyplot as plt
from sklearn import preprocessing
from mpl_toolkits.mplot3d import Axes3D

boston = load_boston()
boston_df = pd.DataFrame(boston.data)
boston_df.columns = boston.feature_names
boston_df['PRICE'] = boston.target

# Setting up the variables
# We want to predict house price based on crime rate and proximity to industry
feature_cols = ['CRIM', 'INDUS']
X = pd.DataFrame(boston_df, columns= feature_cols)
y = pd.DataFrame(boston_df, columns = ['PRICE'])

ya = np.array(y).reshape((-1,))
x_crime = np.array(X['CRIM'])
x_indus = np.array(X['INDUS'])

# Now let's do a multiple regression using both quantitative predictors
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.25, random_state = 0 )
linModel = LinearRegression()
linModel.fit(X_train, y_train)
print(" ")
print('MULTIPLE LINEAR REGRESSION - predict house price based on crime and proximity to industrial areas')
beta_0 = linModel.intercept_
print("Beta_0 (y-intercept) for the model is ", beta_0)
# linModel.coef_ returns the beta coefficients for slope (in same order as passed  --  beta_1, beta_2, etc. for multiple regression)
beta_1_1 = linModel.coef_[0,0]
print("Beta_1 (slope) for predictor ", feature_cols[0], " is ", beta_1_1)
beta_1_2 = linModel.coef_[0,1]
print("Beta_1 (slope) for predictor ", feature_cols[1], " is ", beta_1_2)
y_pred = linModel.predict(X_test)
linModel_score = r2_score(y_test, y_pred)
print ("R^2 score for the model is ", linModel_score)

# do 3d plot of observations
fig = plt.figure(figsize=(12,8))
ax = fig.gca(projection='3d')
ax.scatter3D(x_crime, x_indus, ya, c=ya, cmap='Reds', s=80)
ax.set_xlabel('Crime', fontsize=20)
ax.set_ylabel('Industrial Proximity', fontsize=20)
ax.set_zlabel('House Price', fontsize=20)
plt.title('Actual Observations', fontsize=20)
ax.legend()
plt.show()

#compute estimated tips from the linear model
def f(x1, x2, b0, b1, b2):
    return b0 + b1 * x1 + b2 * x2

est_price = f(x_crime, x_indus, beta_0, beta_1_1, beta_1_2)

#compare estimated tips from the linear model and actual house price
fig = plt.figure(figsize=(12,8))
plt.plot(ya)
plt.plot(est_price)
plt.show()

# compute a surface for the estimated housing price
xx1, xx2 = np.meshgrid(x_crime, x_indus)
Z = f(xx1, xx2, beta_0, beta_1_1, beta_1_2)
# do 3d plot
fig = plt.figure(figsize=(12,8))
ax = fig.gca(projection='3d')
ax.plot_wireframe(xx1, xx2, Z, rstride=5, cstride=6,  alpha=0.2) #cmap='cubehelix', #
ax.scatter3D(x_crime, x_indus, ya, color = 'green', s=80) #c=ya,
ax.set_xlabel('Crime', fontsize=20)
ax.set_ylabel('Industrial Proximity', fontsize=20)
ax.set_zlabel('House Price', fontsize=20)
ax.set_zlim(0, ya.max())
plt.title('Linear Model to Estimate/Predict House Price', fontsize=20)
ax.legend()
plt.show()

︡cac59d2f-c70f-4c46-92b5-da7e018aa8c0︡{"stdout":"LinearRegression(copy_X=True, fit_intercept=True, n_jobs=1, normalize=False)\n"}︡{"stdout":" \n"}︡{"stdout":"MULTIPLE LINEAR REGRESSION - predict house price based on crime and proximity to industrial areas\n"}︡{"stdout":"('Beta_0 (y-intercept) for the model is ', array([ 29.87346629]))\n"}︡{"stdout":"('Beta_1 (slope) for predictor ', 'CRIM', ' is ', -0.25939648415941979)\n"}︡{"stdout":"('Beta_1 (slope) for predictor ', 'INDUS', ' is ', -0.57620303897565217)\n"}︡{"stdout":"('R^2 score for the model is ', 0.12311845095350571)\n"}︡{"stdout":"<mpl_toolkits.mplot3d.art3d.Path3DCollection object at 0x7fb8421a8850>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb84207c890>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb8420554d0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb841c7e0d0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb841c970d0>\n"}︡{"file":{"filename":"0ef14a9f-925b-4417-9383-ff8a9777df9b.svg","show":true,"text":null,"uuid":"fa719e54-1f9d-4e09-8157-c225f8fb8779"},"once":false}︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fb8420221d0>]\n"}︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fb842022790>]\n"}︡{"file":{"filename":"e8405a1f-f927-4663-8fc8-c093b95271bc.svg","show":true,"text":null,"uuid":"cfda230e-47b7-4722-aaff-3f18f5a91fec"},"once":false}︡{"stdout":"<mpl_toolkits.mplot3d.art3d.Line3DCollection object at 0x7fb842cf9150>"}︡{"stdout":"\n"}︡{"stdout":"<mpl_toolkits.mplot3d.art3d.Path3DCollection object at 0x7fb842637910>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb842cf9ed0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb842d08c90>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb842d17c10>\n"}︡{"stdout":"(0, 50.0)\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fb842572810>\n"}︡{"file":{"filename":"ed2c16b8-99a9-43fc-9321-3152cffd7579.svg","show":true,"text":null,"uuid":"db9a4376-3581-4edc-af9b-3cf96b4bf929"},"once":false}︡{"stderr":"Error in lines 70-90\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1013, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 3, in <module>\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sklearn/model_selection/_split.py\", line 2031, in train_test_split\n    arrays = indexable(*arrays)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sklearn/utils/validation.py\", line 229, in indexable\n    check_consistent_length(*result)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sklearn/utils/validation.py\", line 204, in check_consistent_length\n    \" samples: %r\" % [int(l) for l in lengths])\nValueError: Found input variables with inconsistent numbers of samples: [1012, 506]\n"}︡{"done":true}︡
︠a38b42d2-c9d6-4da0-90b7-c2bdda9a58fcs︠
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.model_selection import train_test_split
from sklearn.datasets import load_boston
import seaborn as sns
from sklearn import preprocessing
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
from sklearn.metrics import r2_score
import matplotlib.pyplot as plt
from sklearn import preprocessing
from mpl_toolkits.mplot3d import Axes3D

boston = load_boston()
boston_df = pd.DataFrame(boston.data)
boston_df.columns = boston.feature_names
boston_df['PRICE'] = boston.target

# Setting up the variables
# We want to predict house price based on crime rate and proximity to industry
feature_cols = np.array(['CRIM', 'INDUS'])
X_pdf = pd.DataFrame(boston_df, columns= feature_cols)
y = pd.DataFrame(boston_df, columns = ['PRICE'])

# Linear regression on the two predictors individually
for i in range(len(feature_cols)):
    X = X_pdf[feature_cols[i]]
    X = X.values.reshape(-1, 1)  # a formatting trick required by the built in regression functions in sklearn
    X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.25, random_state = 0 )
    linModel = LinearRegression()
    linModel.fit(X_train, y_train)
    print(" ")
    print('SIMPLE LINEAR REGRESSION FOR PREDICTORS INDIVIDUALLY - predict house price from crime rate and proximity to industrial areas')
    beta_0 = linModel.intercept_
    print("Beta_0 (y-intercept) for model with predictor ", feature_cols[i], " is ", beta_0)
    beta_1 = linModel.coef_[0]
    print("Beta_1 (slope) for model with predictor ", feature_cols[i], " is ", beta_1)
    y_pred = linModel.predict(X_test)
    linModel_score = r2_score(y_test, y_pred)
    print ("R^2 score for model with predictor ", feature_cols[i], " is ", linModel_score)
    plt.subplot(1, 2, i+1)
    plt.scatter(X, y)
    plt.plot(X, beta_0 + beta_1*X)
    plt.ylim(0, )
    plt.title('Simple linear regression for predictor ' + feature_cols[i], fontsize=18)
    plt.text(0,0, "R^2 score = " + str(round(linModel_score,4)), fontsize=18)
    if i==0: plt.ylabel('House Price in Thousands of Dollars', fontsize=18)
plt.show()
︡a059dae2-683b-473f-b82f-5d8c76446666︡{"stdout":"LinearRegression(copy_X=True, fit_intercept=True, n_jobs=1, normalize=False)\n \nSIMPLE LINEAR REGRESSION FOR PREDICTORS INDIVIDUALLY - predict house price from crime rate and proximity to industrial areas\n('Beta_0 (y-intercept) for model with predictor ', 'CRIM', ' is ', array([ 24.13289523]))\n('Beta_1 (slope) for model with predictor ', 'CRIM', ' is ', array([-0.45009754]))\n('R^2 score for model with predictor ', 'CRIM', ' is ', 0.1045581628026393)\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-d9ac106e-6ccf-46b6-b1bc-e97bcbf46956/436/tmp_mUQw9k.svg","show":true,"text":null,"uuid":"a0c5d0ac-bce7-4472-9fdb-a18f5e584c86"},"once":false}︡{"stdout":"<matplotlib.collections.PathCollection object at 0x7fb84320a290>"}︡{"stdout":"\n[<matplotlib.lines.Line2D object at 0x7fb84325a090>]\n(0, 60.0)\n<matplotlib.text.Text object at 0x7fb8420e9f90>\n<matplotlib.text.Text object at 0x7fb8419b9f50>\n<matplotlib.text.Text object at 0x7fb842328510>\nLinearRegression(copy_X=True, fit_intercept=True, n_jobs=1, normalize=False)\n \nSIMPLE LINEAR REGRESSION FOR PREDICTORS INDIVIDUALLY - predict house price from crime rate and proximity to industrial areas\n('Beta_0 (y-intercept) for model with predictor ', 'INDUS', ' is ', array([ 30.30897201]))\n('Beta_1 (slope) for model with predictor ', 'INDUS', ' is ', array([-0.69474972]))\n('R^2 score for model with predictor ', 'INDUS', ' is ', 0.090568807675604601)\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-d9ac106e-6ccf-46b6-b1bc-e97bcbf46956/436/tmp_L0DWRK.svg","show":true,"text":null,"uuid":"d56dd6a7-d5ed-4ffd-822e-9f1fc17428ea"},"once":false}︡{"stdout":"<matplotlib.collections.PathCollection object at 0x7fb841dff290>"}︡{"stdout":"\n[<matplotlib.lines.Line2D object at 0x7fb841dd9510>]\n(0, 60.0)\n<matplotlib.text.Text object at 0x7fb841e1b490>\n<matplotlib.text.Text object at 0x7fb841db81d0>\n"}︡{"file":{"filename":"36e0fad8-fd36-48d4-b6db-0bc43510873b.svg","show":true,"text":null,"uuid":"9b465ef7-25a9-4aee-a4ba-383e536061a3"},"once":false}︡{"done":true}︡
︠03a8de07-c723-42af-82ed-cfd6f83b847a︠









